//+------------------------------------------------------------------+
//|                                                         VQ35.mq4 |
//|                                   http://davidke20.blogspot.com/ |
//+------------------------------------------------------------------+
#property copyright "Alejandro Gallindo"
#property link      "http://davidke20.blogspot.com/"

//int Account=1416863;
extern string     Trades_setup;
extern bool       EcnBroker               = true;
extern string     SymbolsPrefix           = "";
extern string     SymbolsSuffix           = "";
extern bool       UseAutoMagic            = true;
extern int        ManualMagic             = 77218;  
extern double     TakeProfit              = 150;
extern double     Lots                    = 0.01;
extern double     MaxInitialLots          = 6;
extern double     InitialStop             = 0;
extern double     TrailingStop            = 70;
extern bool       Money_management        = true;
extern double     risk                    = 2;

extern string     Martingale_setup;
extern int        MaxTrades               = 5;
extern int        Pips                    = 50;
extern double     Multiplier              = 2;
extern bool       AccountProtection       = true;
extern bool       GlobalEquityProtect     = true;
extern int        OrderstoProtect         = 2;

extern string     Signal_option;
extern string     BullsNBears;
extern int        Fast_Period             = 5;
extern int        Slow_Period             = 13;
extern string     MACD;
extern int        Fast_MA                 = 14;
extern int        Slow_MA                 = 26;
extern int        MACD_SMA                = 9;

extern string     Stochastic;
extern int        K_Period                = 8;
extern int        D_Period                = 3;
extern int        Slowing                 = 4;
extern double     Overbought              = 80;
extern double     Oversold                = 20;
extern int        RSI_Period              = 5;
extern int        MFI_Period              = 5;
extern int        Shift                   = 0;
extern int        ReverseCondition        = 0;

extern string     Conservative_1_Intermediate_2;
extern string     Agressive_3_Berserk_4;
extern int        Engine_Mode             = 3;
extern int        FromHourTrade           = 0;
extern int        ToHourTrade             = 12;

//
//
//
//
//


int    OpenOrders=0, cnt=0;
int    slippage=5;
int    digit = 0;
int    ortype;
int    Magic;
int    mode=0, myOrderType=0;
int    PreviousOpenOrders=0;
int    LastTicket=0, LastType=0;

double LotSizeValue, LotStep, MinLots, MaxLots;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
double LastClosePrice=0, LastLots=0;
double LastPrice=0;
double Profit=0;
double PipValue=0;
double SecureProfit=1;
double PointRatio = 1;
double _Point;

bool   ContinueOpening=True;

string text,text2,engine;
string s_symbol;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init() 
{
                
   s_symbol = Symbol();
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic; 
              
              
return(0);
}

//+------------------------------------------------------------------+
//|                               
//+------------------------------------------------------------------+
//
//

int deinit() {   return(0);  }

//+------------------------------------------------------------------+
//|                                          
//+------------------------------------------------------------------+
//
//

int start()
{
  
   if(Period()<30){Comment("Do not use anything below M30");return;}
   
   //
   //
   //
   //
   //
   
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==3 || digit==5) 
         PointRatio = 10;
   else  PointRatio = 1; 
   _Point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
  
  //
  //
  //
  //
  //
  
  LotSizeValue = NormalizeDouble((MarketInfo(s_symbol, MODE_LOTSIZE)),0);   
  LotStep      = NormalizeDouble((MarketInfo(s_symbol, MODE_LOTSTEP)),2);
  MinLots      = NormalizeDouble((MarketInfo(s_symbol, MODE_MINLOT)) ,2);
  MaxLots      = NormalizeDouble((MarketInfo(s_symbol, MODE_MAXLOT)) ,2);
  
  if(MaxInitialLots>0) MaxLots=MaxInitialLots;

   if (Money_management)
   {
      //Standard Account offering $10,000 
      //
      //
      //
      //
      
      if (LotSizeValue == 100000 && LotStep == 0.10)
      {
      lotsi = NormalizeDouble(((AccountBalance() * (risk/100) ) / ((LotSizeValue * LotStep)/10)),1);
      if (lotsi < MinLots) lotsi = MinLots;
      if (lotsi > MaxLots) lotsi = MaxLots;      
      }
      
      //Standard Account offering $1,000 lotstep
      //
      //
      //
      //
      
      if (LotSizeValue == 100000 && LotStep == 0.01)
      {
      lotsi = NormalizeDouble(((AccountBalance() * (risk/100) ) / (LotSizeValue * LotStep)),2); 
      if (lotsi < MinLots) lotsi = MinLots;
      if (lotsi > MaxLots) lotsi = MaxLots;      
      }
      
      //IBFX mini Account offering $100 lotstep
      //
      //
      //
      //
      
      if (LotSizeValue == 10000  && LotStep == 0.01)
      {
      lotsi = NormalizeDouble(((AccountBalance() * (risk/100) ) / (LotSizeValue * LotStep)),2); 
      if (lotsi < MinLots) lotsi = MinLots;
      if (lotsi > MaxLots) lotsi = MaxLots;      
      }      
   
   }
   else lotsi = Lots;
   
   //-- End of money management
   //
   //
   //
   //

   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   //
   //
   //
   //
   //
   
   if (OpenOrders<1)
   
   PipValue=MarketInfo(s_symbol,MODE_TICKVALUE);
   if (PipValue==0) { PipValue=10; }
   
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY)  { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*_Point,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*_Point, Red); }
			return(0);
		 }
	  }
   }
   
   //
   //
   //
   //
   //
   
   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }
   
   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY)  { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }
   
   //
   //
   //
   //
   //
   
   if (OpenOrders<1) 
   {
     if (Engine_Mode!=4)
     {//check trading time
        if ((!(Hour()>FromHourTrade && Hour()<ToHourTrade)) && (DayOfWeek()==5)) 
        {Comment("No trading, danger time zone!");
        return(0);}//End of trading time check
     }
     
    //	  
    //	  
    //
    //    
    //      
    
    switch(Engine_Mode)
    {
      case 1:  {Magic=Magic+Engine_Mode;myOrderType=Conservative(); engine =" Conservative";}
      case 2:  {Magic=Magic+Engine_Mode;myOrderType=Intermediate(); engine =" Intermediate";}
      case 3:  {Magic=Magic+Engine_Mode;myOrderType=Agressive();    engine =" Agressive";}
      case 4:  {Magic=Magic+Engine_Mode;myOrderType=Berserk();      engine =" Berserk";}
      default: {Magic=Magic+Engine_Mode;myOrderType=Agressive();    engine =" Agressive";}
    }
    
    //
    //
    //
    //
    //
    
	 if (ReverseCondition==1)
	 {
	  	 if (myOrderType==1)        { myOrderType=2; }
		 else { if (myOrderType==2) { myOrderType=1; } }
	  }
   }
   
   //
   //
   //
   //
   //
   
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if (OrderOpenPrice()-Ask>=(TrailingStop*_Point+Pips*_Point)) 
				  {						
					 if (OrderStopLoss()>(Ask+_Point*TrailingStop))
					 {			
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+_Point*TrailingStop,OrderClosePrice()-TakeProfit*_Point-TrailingStop*_Point,0,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if (Bid-OrderOpenPrice()>=(TrailingStop*_Point+Pips*_Point)) 
				{
					if (OrderStopLoss()<(Bid-_Point*TrailingStop)) 
					{					   
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-_Point*TrailingStop,OrderClosePrice()+TakeProfit*_Point+TrailingStop*_Point,0,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
   }
   
   //
   //
   //
   //
   //
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==s_symbol && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{
					
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/_Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/_Point; }
			}
			if (LastType==OP_SELL) 
			{
			
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/_Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/_Point; }
			}
	  }
   }

   
   //
   //
   //
   //
   //
   
   if(Money_management) {SecureProfit=(AccountEquity()/LotSizeValue*risk);}
   else
   {SecureProfit=(AccountEquity()/LotSizeValue*lotsi);}

	Profit=Profit*PipValue;
	text2="\nCurrent engine''s profit: $"+DoubleToStr(Profit,2)+" +/-";
   if (OpenOrders>=OrderstoProtect && AccountProtection) 
   {	  
	     
	     if (AccountProfit()>=SecureProfit && GlobalEquityProtect) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage*_Point,Yellow);
	        ContinueOpening=False;
	        return(0);
	     }
	     if (Profit>=SecureProfit && (!GlobalEquityProtect))
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage*_Point,Yellow);
	        ContinueOpening=False;
	        return(0);
	     }
   }
   
   //
   //
   //
   //
   //

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="\nNo conditions to open trades"; }
	     else { text="                         "; }
	     Comment("\nLastPrice=",LastPrice,"\nPrevious open orders=",PreviousOpenOrders,"\nContinue opening=",
	     ContinueOpening," OrderType=",myOrderType,"\nLot size: ",lotsi,"\nEngine mode=",engine,"\nCurrentGlobalProfit=",AccountProfit(),
	     text2,"\n",text,"\n","\nFreeware available at http://goldenmoneytree.com","\nfor exclusive member",
	     "\nDo not BUY this product!");
      }
      
      //
      //
      //
      //
      //
      
      if (myOrderType==1 && ContinueOpening) 
      {	
	     if ((Bid-LastPrice)>=Pips*_Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*_Point; }
		    	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*_Point + (MaxTrades-OpenOrders)*Pips*_Point, digit);  }
		    
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    
		    //
		    //
		    //
		    //
		    //
		    
		    if (!EcnBroker)
   		       OrderSend(s_symbol,OP_SELL,mylotsi,SellPrice,slippage*_Point,sl,tp,"VQ35"+engine,Magic,0,Red);		    		    
          else
          {
                int sellTicket = OrderSend(s_symbol,OP_SELL,mylotsi,SellPrice,slippage*_Point,0,0,"VQ35"+engine,Magic,0,Red);		    		    
                if (sellTicket >= 0)
                  OrderModify(sellTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
          }		       
		    return(0);
	     }
      }
      
      //
      //
      //
      //
      //
      
      if (myOrderType==2 && ContinueOpening) 
      {
	     if ((LastPrice-Ask)>=Pips*_Point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*_Point; }	
		    
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*_Point - (MaxTrades-OpenOrders)*Pips*_Point, digit); }
		    
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;
			   			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    
		    //
		    //
		    //
		    //
		    //
		    
		    if (!EcnBroker)
   		       OrderSend(s_symbol,OP_BUY,mylotsi,BuyPrice,slippage*_Point,sl,tp,"VQ35"+engine,Magic,0,Blue);		    
          else
          {
                int buyTicket = OrderSend(s_symbol,OP_BUY,mylotsi,BuyPrice,slippage*_Point,0,0,"VQ35"+engine,Magic,0,Blue);
                if (buyTicket >= 0)
                  OrderModify(buyTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
          }		       
		    return(0);
	     }
      }   

   return(0);
  }
  
//+------------------------------------------------------------------+
//
//
//
//

int Conservative()
{
      myOrderType=3;
      double bullhighpre = iBullsPower(s_symbol,0,Slow_Period,0,Shift+1);
      double bullhighcur = iBullsPower(s_symbol,0,Slow_Period,0,Shift);
      double bearhighpre = iBearsPower(s_symbol,0,Slow_Period,0,Shift+1);
      double bearhighcur = iBearsPower(s_symbol,0,Slow_Period,0,Shift);
      double bulllow     = iBullsPower(s_symbol,0,Fast_Period,0,Shift);
      double bearlow     = iBearsPower(s_symbol,0,Fast_Period,0,Shift);
      
         if (bearhighcur>bearhighpre && bearhighcur>0 && bearhighpre>0
         && bullhighcur>bullhighpre && bulllow>0 && bearlow>0)
         { myOrderType=2;}
         
         if (bearhighcur<bearhighpre && bearhighcur<0 && bearhighpre<0
         && bullhighcur<bullhighpre && bulllow<0 && bearlow<0)
         { myOrderType=1;}
         
	return(myOrderType);
}

//
//
//
//
//

int Intermediate()
{
	  int myOrderType=3;
	  if (iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)>0 &&
	      iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)<0)     { myOrderType=2; }
	  
	  if (iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)<0 &&
	      iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)>0)     { myOrderType=1; }
	  return(myOrderType);
}

//
//
//
//
//

int Agressive()
{
      int myOrderType=3;
      double StochMain   = iStochastic(s_symbol,0,K_Period,D_Period,Slowing,MODE_EMA,1,MODE_MAIN,Shift);
      double StochSignal = iStochastic(s_symbol,0,K_Period,D_Period,Slowing,MODE_EMA,1,MODE_SIGNAL,Shift);
      double StochShift  = iStochastic(s_symbol,0,K_Period,D_Period,Slowing,MODE_EMA,1,MODE_MAIN,Shift+1);
      double RSI         = iRSI(s_symbol,0,RSI_Period,PRICE_CLOSE,Shift);
      double RSIShift    = iRSI(s_symbol,0,RSI_Period,PRICE_CLOSE,Shift+1);
      double MFI         = iMFI(s_symbol,0,MFI_Period,Shift);
      double MFIShift    = iMFI(s_symbol,0,MFI_Period,Shift+1);
      
      if   (StochMain > StochSignal &&
            StochMain > StochShift &&
            StochMain < Overbought &&
            StochMain > Oversold &&
            RSI > RSIShift &&
            MFI > MFIShift)
            { myOrderType = 2; }

      if   (StochMain < StochSignal &&
            StochMain < StochShift &&
            StochMain < Overbought &&
            StochMain > Oversold &&
            RSI < RSIShift &&
            MFI < MFIShift)
            { myOrderType = 1; }

      return(myOrderType);
}

//
//
//
//
//

int Berserk()
{
	  if (iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)>
	      iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)) { myOrderType=2; }
	      
	  if (iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)<
	      iMACD(s_symbol,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)) { myOrderType=1; }
	  return(myOrderType);
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(11921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(12922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(13931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(14932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(15941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(16942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(17951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(18961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(19971);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(20963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(21964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(22965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(23966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(24967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(25971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(26972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(27973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(28981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(29982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(30983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(31991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(32992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(33993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(34994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(35995);
   
return(ManualMagic);
}

